import React from 'react';
import ReactDOM from 'react-dom';
import './App.css';

interface SquareGameProps {
  value: any
  onClick: Function
}

interface SquareGameState{
  value: any

  // whatever other state we add here
}

interface BoardGameProps {
  
}

interface BoardGameState {
  squares: any
  xIsNext: boolean
}

function App() {
  return (
    <Game />
  );
}

class Square extends React.Component<SquareGameProps, SquareGameState> {
  render() {
    return(
      <button className='square' onClick={() => { this.props.onClick() }}>
        { this.props.value }
      </button>
    );
  }
}

class Board extends React.Component<BoardGameProps, BoardGameState> {
  constructor(props: any) {
    super(props);

    this.state = {
      squares: Array(9).fill(null),
      xIsNext: true,
    }
  }

  handleClick(i: string | number) {
    const squares = this.state.squares.slice();
    if (calculateWinner(squares) || squares[i]) {
      return;
    }
    squares[i] = this.state.xIsNext ? 'X' : 'O';
    this.setState({
      squares: squares,
      xIsNext: !this.state.xIsNext,
    });
  }

  renderSquare(i: string | number) {
    return <Square value={this.state.squares[i]} onClick={() => this.handleClick(i)}/>
  }

  render() {
    const winner = calculateWinner(this.state.squares);
    let status;

    if (winner) {
      status = 'Winner: ' + winner;
    }
    else {
      status = `Next player: ${this.state.xIsNext ? 'X' : 'O'}`;
    }

    return(
      <div>
        <div className="status">{status}</div>
        <div className="board-row">
          {this.renderSquare(0)}
          {this.renderSquare(1)}
          {this.renderSquare(2)}
        </div>
        <div className="board-row">
          {this.renderSquare(3)}
          {this.renderSquare(4)}
          {this.renderSquare(5)}
        </div>
        <div className="board-row">
          {this.renderSquare(6)}
          {this.renderSquare(7)}
          {this.renderSquare(8)}
        </div>
      </div>
    );
  }
}

class Game extends React.Component {
  render() {
    return(
      <div className='game'>
        <div className='game-board'>
          <Board />
        </div>
        <div className='game-info'>
          <div>{ /* status */ }</div>
          <ol>{ /* todo */ }</ol>
        </div>
      </div>
    );
  }
}

function calculateWinner(squares: any) {
  const lines = [
    [0, 1, 2],
    [3, 4, 5],
    [6, 7, 8],
    [0, 3, 6],
    [1, 4, 7],
    [2, 5, 8],
    [0, 4, 8],
    [2, 4, 6],
  ];

  lines.forEach((i: any) => {
    const [a, b, c] = i;

    if (squares[a] && squares[b] === squares[a] && squares[c]) {
      return squares[a];
    }
  });

  return null;
}

export default App;
